;;drawing line from 2 cordinates
.proc line
    ;;#  (X_pos, Y_pos)                                     #
    ;;#                     *                               #
    ;;#                         *                           #
    ;;#                             *                       #
    ;;#                                (X_end, Y_end)       #
    ;;NOTE THAT X_pos <= X_end, Y_pos <= Y_end. Max 45deg!

    ;;Not values but register position in memory
    X_end = $04
    Y_end = $05
    X_pos = $FC
    Y_pos = $FB
    dx = $0c
    dy_2 = $0607
    V = $0809 ;Lets reuse dx register ($08)
    D = $0a0b

    ;example values ~~~~~ SHOULD BE PRECOMPILED
    LDA #$00
    STA X_pos
    STA Y_pos

    LDA #$90
    STA X_end
    LDA #$10
    STA Y_end
    ;;~~~~~~~~~~


    ;;We need to clear this memory
    LDA #$00
    STA <V
    STA <dy_2
    STA $FD ; for pixel_draw

    ;; V = 2*(dx -dy)
    ;; where: dy = Y_end - Y_start, dx = X_end - X_start
    LDA Y_end
    SEC
    SBC Y_pos
    STA >V
    STA >dy_2;  >dy_2 = dy. Needed for dy_2 (not for V)
    LDA X_end
    SEC
    SBC X_pos
    STA dx
    SEC
    SBC >V
    STA >V; <V = dx - dy
    mult_16 >V, <V; V = 2*(dx -dy)

    ;dy_2 = dy*2
    mult_16 >dy_2, <dy_2

    ;;D = 2*dy - dx + 2*255
    ;;Our D is bigger then wikipedia because D is unsigned.
    LDA >dy_2
    STA >D
    LDA <dy_2
    STA <D
    Add_16 >D, <D, #$00, #$01
    Sub_16 >D, <D, dx, #$00

for_x:
    jsr pixel_draw
    ;;Increment X until X_pos = X_end and Y_pos = Y_end
    INC X_pos
    LDX X_pos
    CPX X_end
    BEQ end

    ;;If D <  %00000001 11111111 <==> >D ==0, then: case_2
    LDA <D; if <D > 0 then: case_1
    CMP #$00
    BEQ case_2
case_1:
    INC Y_pos
    Sub_16 >D, <D, >V, <V; D = D - V
    JMP for_x
case_2:
    Add_16 >D, <D, >dy_2, <dy_2;D = D + 2*dy
    JMP for_x
end:
.endproc
